<template>
  <div class="mb-3">
    <v-expansion-panels focusable>
      <v-expansion-panel>
        <v-expansion-panel-header class="py-1 px-2">
          <v-chip 
            dark
            class="d-flex justify-center text-white mr-3"
            style="max-width:90px; min-width:90px;"
            label
            :color="color"
            dense
          >
          {{resource.operacao}}
          </v-chip>
          <div
            class="d-flex flex-wrap"
            style="color: rgb(59, 65, 81);"
          >
            <pre v-if="routeSanitazed.length > 1"><b>{{routeSanitazed}}</b></pre>
            <span class="ml-2">{{resource.titulo}}</span>
          </div>
        </v-expansion-panel-header>
        <v-expansion-panel-content>
          <v-row>
            <div class="text-subtitle-1 ml-3 my-2"><b>Descrição:</b> {{resource.descricao}}</div>
          </v-row>
          <v-card class="my-2">
            <v-card-text>
              <h3
                class="display-1"
                :color="$vuetify.theme.dark ? 'grey darken-3' : 'grey lighten-1'"
              >Request</h3>
              <v-row>
                <v-col cols="12" md="5"></v-col>
                <v-col cols="12" md="7">
                  <vx-jsonViewer
                    :json-viewer-options="jsonViewerOptionsRequest"
                    :dataValue="schemaRequestComputed"
                    body-style="max-height: 400px; overflow: scroll;"
                  >
                    <template v-slot:header>
                      Request Schema
                      <v-spacer></v-spacer>
                    </template>
                  </vx-jsonViewer>
                </v-col>
              </v-row>
            </v-card-text>
          </v-card>
          <v-card class="my-2">
            <v-card-text>
              <h3
                class="display-1"
                :color="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'"
              >Response</h3>
              <v-row>
                <v-col cols="12" md="5">
                  <div
                    class="d-flex flex-row"
                    v-for="(param, key) in this.urlParameters"
                    :key="key"
                  >
                    <span class="mr-2">{{param}}: </span>
                    <v-text-field
                      outlined
                      dense
                      :ref="`route-${routeId}-param-${param}`"
                    ></v-text-field>
                  </div>
                  <div class="d-flex float-right">
                    <v-btn
                      rounded
                      color="info"
                      :loading="loadingRequest"
                      @click="sendRequest()"
                    >
                      <v-icon left>mdi-send</v-icon> Enviar
                    </v-btn>
                  </div>
                </v-col>
                <v-col cols="12" md="7">
                  <vx-jsonViewer
                    :json-viewer-options="jsonViewerOptionsResponse"
                    :dataValue="schemaRespenseComputed"
                    body-style="max-height: 600px; overflow: scroll;"
                  >
                    <template v-slot:header>
                      Response Schema
                      <v-spacer></v-spacer>
                    </template>
                  </vx-jsonViewer>
                </v-col>
              </v-row>
            </v-card-text>
          </v-card>
        </v-expansion-panel-content>
      </v-expansion-panel>
    </v-expansion-panels>
  </div>
</template>

<script>
import { mapActions, mapState } from "vuex";
import jsonViewer from "./JsonViewer.vue";

export default {
  name: 'ApiRouteView',
  components:{
    'vx-jsonViewer': jsonViewer
  },
  props:[
    'resource',
    'dark',
    'routeId',
    'requestURLBase',
  ],
  computed:{
    ...mapState(["JSON_API_DISCOVERY", "THEME"]),
    routeSanitazed(){
      let sanitazedRoute = this.resource.rota

      if (this.resource === undefined || this.resource.rota === undefined ||  (typeof this.resource.rota !== 'string')) {
        return "Rota não informada"
      }

      if (this.JSON_API_DISCOVERY.contexto !== undefined && this.JSON_API_DISCOVERY.contexto !== null && this.JSON_API_DISCOVERY.contexto !== '') {
       if (this.JSON_API_DISCOVERY.contexto === "/" && sanitazedRoute.startsWith("/")){
          return sanitazedRoute.substring(1, sanitazedRoute.length);
        }
        if (this.resource.rota.includes(this.JSON_API_DISCOVERY.contexto)) {
          sanitazedRoute = this.resource.rota.split(this.JSON_API_DISCOVERY.contexto)[1]
          
        }
      }

      return sanitazedRoute
    },
    color(){
      return this.resource.operacao === 'POST'? 'green darken-4':
      this.resource.operacao === 'PUT'? 'orange darken-4':
      this.resource.operacao === 'DELETE'? 'red darken-4':
      'primary darken-2'
    },
    jsonViewerOptionsRequest(){
      return {
        maxDepth: 3,
        modifiable: false,
        link: true,
        limitRenderDepth: false,
        theme: (this.dark)
      }
    },
    jsonViewerOptionsResponse(){
      return {
        maxDepth: 3,
        modifiable: false,
        link: true,
        limitRenderDepth: false,
        theme: (this.dark)
      }
    },
    schemaRequestComputed(){
      if(! Array.isArray(this.resource.requestSchema)){
        return  this.resource.requestSchema
      }

      let computedArray = {}
      this.resource.requestSchema.map(property => {
        computedArray[property.name] = property.type
      })
      return computedArray
    }
  },
  data: () => ({
    urlParameters:[],
    loadingRequest: false,
    schemaRespenseComputed: {}
  }),
  methods:{
    ...mapActions(["showSnack"]),
    sendRequest(){
      let self = this
      let routeWithParams = JSON.parse(JSON.stringify(this.routeSanitazed))

      this.urlParameters.map(parameter =>{
        routeWithParams = routeWithParams.replace(`{${parameter}}`, this.$refs[`route-${this.routeId}-param-${parameter}`][0].internalValue)
      })

      this.$axios({
        url: self.requestURLBase+routeWithParams,
        method: self.resource.operacao
      }).then(res =>{
        self.schemaRespenseComputed = res.data
        self.showSnack("ENVIADO.")
      }).catch(err =>{
        self.showSnack("Erro.<br/> Consulte o log para verificar o erro")
        self.schemaRespenseComputed = err.response.data
        console.log(err.response.data)
      })
    }
  },
  mounted() {
    if (this.resource.rota != null ){
      let regex = /{(\w+)}/g
      let match = regex.exec(this.resource.rota)
      while (match != null) {
        this.urlParameters.push(match[1])
        match = regex.exec(this.resource.rota)
      }
    }
  }
}
</script>
